/***********************************************************************
 *      ̃TvvO͈ȉ̏Ђ̔łB             *
 *                                                                     *
 *          X Window OSF/Motif c[Lbg vO~O (II)        *
 *            - OtBbNEƎ\[XE{EʐM -             *
 *                                                                     *
 *      Copyright 1995,  GK                                        *
 *                                                                     *
 *      쌠\Ƃ̒ӏ܂܂ĂA                   *
 *      ̃TvvOzzĂ܂܂B                 *
 ***********************************************************************/

#include <Xm/XmAll.h>

#define ARC 10
#define X 20
#define Y 20
static GC gc;
static Dimension width, height;
static unsigned int rw = 0, rh = 0;
static int px, py;

/* h[GÃTCY𒲂ׂĐ}`̈ʒuƃTCYČvZ */
static void ResetSizeAndPos(w)
    Widget w;
{
    unsigned int old_w, old_h;
    old_w = rw;
    old_h = rh;

    /* h[GÃTCY𒲂ׂ */
    XtVaGetValues(w, XmNwidth, &width, XmNheight, &height, NULL);

    /* `̃TCYČvZ */
    rw = width - X * 2;
    rh = height - Y * 2;

    /* ~̈ʒuČvZ */
    if (old_w == 0) px = width / 2;
    else            px = (double)(px - X) * (double)rw / (double)old_w + X;
    if (old_h == 0) py = height / 2;
    else            py = (double)(py - Y) * (double)rh / (double)old_h + Y;
}

/* h[GAɐ}`` */
static void Redraw(w)
    Widget w;
{
    XDrawRectangle(XtDisplay(w), XtWindow(w), gc, X, Y, rw, rh);
    XFillArc(XtDisplay(w), XtWindow(w), gc, px - ARC/2, py - ARC/2, ARC, ARC,
             0, 360*64);
}

/* (5) Cxg֐ŕ`揈 (R[obN) */

/* h[GÃTCYςƐ}`̃TCYČvZ */
static void ResizeCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    ResetSizeAndPos(w);
    XClearWindow(XtDisplay(w), XtWindow(w));
    Redraw(w);
}

/* h[GAIoƂɐ}`ĕ` */
static void ExposeCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    Redraw(w);
}

/* h[GAŃ{^ꂽꏊɐ}`` */
static void InputCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    XmDrawingAreaCallbackStruct *cb = (XmDrawingAreaCallbackStruct *)call_data;
    if (cb->event->type == ButtonPress) {
        px = cb->event->xbutton.x;
        py = cb->event->xbutton.y;
        XClearWindow(XtDisplay(w), XtWindow(w));
        Redraw(w);
    }
}

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget   toplevel, panel, canvas;
    Arg      al[20];
    int      ac;

    XtSetLanguageProc(NULL, NULL, NULL);
    ac = 0;
    /* (1) Xc[Lbg (fBXvCI[v) */
    toplevel = XtAppInitialize(&app_context, "XMdraw", NULL, 0,
                               &argc, argv, NULL, al, ac);

    ac = 0;
    panel = XmCreateForm(toplevel, "panel", al, ac);
    XtManageChild(panel);

    ac = 0;
    /* (2) EBWFbg쐬ă}l[W */
    canvas = XmCreateDrawingArea(panel, "canvas", al, ac);
    XtManageChild(canvas);
    /* (3) Cxg֐ (R[obN) ̓o^ */
    XtAddCallback(canvas, XmNresizeCallback, ResizeCB, NULL);
    XtAddCallback(canvas, XmNexposeCallback, ExposeCB, NULL);
    XtAddCallback(canvas, XmNinputCallback,  InputCB,  NULL);

    /* ̈ʒuƃTCYvZ */
    ResetSizeAndPos(canvas);

    XtRealizeWidget(toplevel);
    /* (2') ŃEBhE */

    /* (4) OtBbNEReLXg쐬ݒ */
    gc = XCreateGC(XtDisplay(canvas), XtWindow(canvas), NULL, NULL);
    XSetLineAttributes(XtDisplay(canvas), gc, 2, LineSolid, CapButt, JoinMiter);

    XtAppMainLoop(app_context);
}
