/***********************************************************************
 *      ̃TvvO͈ȉ̏Ђ̔łB             *
 *                                                                     *
 *          X Window OSF/Motif c[Lbg vO~O (II)        *
 *            - OtBbNEƎ\[XE{EʐM -             *
 *                                                                     *
 *      Copyright 1995,  GK                                        *
 *                                                                     *
 *      쌠\Ƃ̒ӏ܂܂ĂA                   *
 *      ̃TvvOzzĂ܂܂B                 *
 ***********************************************************************/

#include <Xm/XmAll.h>

extern Boolean CvtStrToBitmap(); /* \[XERo[^ */

static GC gc; /* OtBbNEReLXg (Xlib ̕`ɕKv) */
static Widget label;

static void ChangeBitmapCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    Widget text = (Widget)client_data;
    char *filename; /* rbg}bvEt@C (ϊf[^) */
    XrmValue source, dest; /* \[Xl\ */
    Pixmap bitmap;

    /* (1) Vrbg}bvEt@C */
    filename = XmTextFieldGetString(text);
    /* (2) ͂ȂƁC͗̈ɃtH[JX𓖂Ăăx炷 */
    if (filename == NULL || *filename == NULL) {
        XmProcessTraversal(text, XmTRAVERSE_CURRENT);
        XBell(XtDisplay(w), 0);
        return;
    }

    /* sbNX}bvp̃\[Xl\̂ */
    source.size = strlen(filename) + 1;  /* ϊf[^̃TCY */
    source.addr = filename;              /* ϊ̃f[^ */
    dest.size = sizeof(Pixmap);   /* ϊf[^̃TCY (̏ꍇ͐l) */
    dest.addr = &bitmap;          /* ϊf[^̊i[̈ */

    /* (3) rbg}bvEt@CsbNX}bv (Pixmap^) ɕϊ */
    if (!XtConvertAndStore(label, XtRString, &source, XtRBitmap, &dest)) {
        /* (4) ϊɎsƁC͗̈ɃtH[JX𓖂Ăăx炷 */
        XmProcessTraversal(text, XmTRAVERSE_CURRENT);
        XBell(XtDisplay(w), 0);
        return;
    }

    /* (5) sbNX}bvxɕ\ */
    XtVaSetValues(label, XmNlabelPixmap, bitmap, NULL);
}

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget toplevel, panel, text, button;
    Arg    al[20];
    int    ac;
    XtConvertArgRec args[2];  /* \[XERo[^ɓn⏕f[^ */
    Screen *screen;

    XtSetLanguageProc(NULL, NULL, NULL);
    ac = 0;       /* \[XEf[^x[X */
    toplevel = XtAppInitialize(&app_context, "Bitmapcnv", NULL, 0,
                               &argc, argv, NULL, al, ac);

    /* \[XERo[^ɓn⏕f[^ */
    screen = XtScreen(toplevel);
    args[0].address_mode = XtAddress;
    args[0].address_id = (XtPointer)&screen;
    args[0].size = sizeof(Screen *);
    args[1].address_mode = XtAddress;
    args[1].address_id = (XtPointer)&label;
    args[1].size = sizeof(Widget);

    /* (6) rbg}bvEt@C Pixmap ւ̃\[XERo[^o^ */
    XtAppSetTypeConverter(app_context, XtRString, XtRBitmap, CvtStrToBitmap,
                          args, XtNumber(args), XtCacheByDisplay, NULL);

    ac = 0;
    panel = XmCreateForm(toplevel, "panel", al, ac);
    XtManageChild(panel);

    ac = 0;
    XtSetArg(al[ac], XmNlabelType, XmPIXMAP); ac++;
    label = XmCreateLabel(panel, "label", al, ac);
    XtManageChild(label);

    ac = 0;
    text = XmCreateTextField(panel, "text", al, ac);
    XtManageChild(text);

    ac = 0;
    button = XmCreatePushButton(panel, "button", al, ac);
    XtManageChild(button);

    XtAddCallback(button, XmNactivateCallback, ChangeBitmapCB, text);

    XtVaSetValues(label, XmNbottomWidget, text,   NULL);
    XtVaSetValues(text,  XmNbottomWidget, button, NULL);

    XtRealizeWidget(toplevel);
    gc = XCreateGC(XtDisplay(label), XtWindow(label), NULL, NULL);
    XtAppMainLoop(app_context);
}
