/***********************************************************************
 *      ̃TvvO͈ȉ̏Ђ̔łB             *
 *                                                                     *
 *          X Window OSF/Motif c[Lbg vO~O (II)        *
 *            - OtBbNEƎ\[XE{EʐM -             *
 *                                                                     *
 *      Copyright 1995,  GK                                        *
 *                                                                     *
 *      쌠\Ƃ̒ӏ܂܂ĂA                   *
 *      ̃TvvOzzĂ܂܂B                 *
 ***********************************************************************/

#include <Xm/XmAll.h>

static void OpenCB();
static void CopyCB();
static void PasteCB();
static void CopyByName();

static Widget text;

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget toplevel, panel, field, label, fname, open, control, copy, paste;
    Arg al[20];
    int ac;

    XtSetLanguageProc(NULL, NULL, NULL);
    ac = 0;
    toplevel = XtAppInitialize(&app_context, "Clipbyname", NULL, 0,
                               &argc, argv, NULL, al, ac);

    ac = 0;
    panel = XmCreateForm(toplevel, "panel", al, ac);
    XtManageChild(panel);

    /* (1) t@C͂ăI[v̈ */
    ac = 0;
    field = XmCreateRowColumn(panel, "field", al, ac);
    XtManageChild(field);
    /* "t@C: */
    ac = 0;
    label = XmCreateLabel(field, "label", al, ac);
    XtManageChild(label);
    /* ͗̈ */
    ac = 0;
    fname = XmCreateTextField(field, "fname", al, ac);
    XtManageChild(fname);
    /* [I[v] */
    ac = 0;
    open = XmCreatePushButton(field, "open", al, ac);
    XtAddCallback(open, XmNactivateCallback, OpenCB, fname);
    XtManageChild(open);

    /* (2) t@C̓e\̈ */
    ac = 0;
    text = XmCreateScrolledText(panel, "text", al, ac);
    XtManageChild(text);

    /* (3) ̈ */
    ac = 0;
    control = XmCreateRowColumn(panel, "control", al, ac);
    XtManageChild(control);
    /* [Rs[] --> Nbv{[hɃf[^Rs[ */
    ac = 0;
    copy = XmCreatePushButton(control, "copy", al, ac);
    XtAddCallback(copy, XmNactivateCallback, CopyCB, NULL);
    XtManageChild(copy);
    /* [y[Xg] --> Nbv{[hf[^o */
    ac = 0;
    paste = XmCreatePushButton(control, "paste", al, ac);
    XtAddCallback(paste, XmNactivateCallback, PasteCB, NULL);
    XtManageChild(paste);

    XtVaSetValues(XtParent(text), XmNtopWidget, field,
                                  XmNbottomWidget, control, NULL);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}

/* (4) [I[v] {^̃R[obN */
static void OpenCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    Widget textf = (Widget)client_data;
    char *filename;
    FILE *fp;
    char buff[BUFSIZ];

    /* (5) ͂ꂽt@Co */
    XtVaGetValues(textf, XmNvalue, &filename, NULL);

    /* (6) t@C̓eeLXgɕ\ */
    if ((fp = fopen(filename, "r")) != NULL) {  /* t@CI[v */
        XmTextSetString(text, "");  /* eLXg̓e */
        while (fgets(buff, BUFSIZ, fp) != NULL)
            XmTextInsert(text, XmTextGetLastPosition(text), buff); /* ǉ */
        fclose(fp);
    }

    XtFree(filename);
}

/* (7) [Rs[] {^̃R[obN */
static void CopyCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    XmString label;
    long item_id;
    static int private_id = 0;
    long data_id;

    /* KȖOŃRpEhEXgOĂ */
    label = XmStringCreateLocalized("_my_text");

    /* (8) ORs[Jn */
    if (XmClipboardStartCopy(XtDisplay(text), XtWindow(text), label,
                             XtLastTimestampProcessed(XtDisplay(text)),
                             text, CopyByName, &item_id) != ClipboardSuccess) {
        XBell(XtDisplay(text), 0);
        XmStringFree(label);
        return;
    }
    /* (9) tH[}bgRs[ */
    if (XmClipboardCopy(XtDisplay(text), XtWindow(text), item_id, "STRING",
                        NULL, XmTextGetLastPosition(text) * 2,
                        private_id, &data_id) != ClipboardSuccess) {
        XmClipboardCancelCopy(XtDisplay(text), XtWindow(text), item_id);
        XBell(XtDisplay(text), 0);
        XmStringFree(label);
        return;
    }
    /* (10) ORs[I */
    if (XmClipboardEndCopy(XtDisplay(text), XtWindow(text), item_id)
                                                       != ClipboardSuccess) {
        XBell(XtDisplay(text), 0);
        XmStringFree(label);
        return;
    }
    private_id++;
    XmStringFree(label);
}

/* (11) Nbv{[h̃f[^vꂽƂɌĂяo */
static void CopyByName(w, data_id, private_id, reason)
    Widget w;
    int *data_id;
    int *private_id;
    int *reason;
{
    char *string;

    if (*reason == XmCR_CLIPBOARD_DATA_REQUEST) {
        /* (12) eLXgEEBWFbg̒go */
        string = XmTextGetString(text);
        /* (13) ۂ̃f[^Rs[ */
        if (XmClipboardCopyByName(XtDisplay(text), XtWindow(text), *data_id,
                    string, strlen(string), *private_id) != ClipboardSuccess) {
            XBell(XtDisplay(text), 0);
            XtFree(string);
            return;
        }
        XtFree(string);
    }
    else { /* *reason == XmCR_CLIPBOARD_DATA_DELETE */
        /* (14) 폜̗vƂ̏ */
    }
}

/* (15) [y[Xg] {^̃R[obN */
static void PasteCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    char buff[BUFSIZ];
    unsigned long num_bytes;
    long private_id;
    int status;

    /* (16) f[^̎oJn */
    if (XmClipboardStartRetrieve(XtDisplay(text), XtWindow(text),
              XtLastTimestampProcessed(XtDisplay(text))) != ClipboardSuccess) {
        XBell(XtDisplay(text), 0);
        return;
    }

    /* (17) eLXg̓eNA */
    XmTextSetString(text, "");

    /* (18) TCYƂɃf[^o */
    do {
        status = XmClipboardRetrieve(XtDisplay(text), XtWindow(text),
                       "STRING", buff, sizeof(buff), &num_bytes, &private_id);
        /* (19) of[^eLXgɒǉ */
        if (status == ClipboardSuccess || status == ClipboardTruncate) {
            buff[num_bytes] = '\0';  /* Ō NULL t */
            XmTextInsert(text, XmTextGetLastPosition(text), buff);
        }
    } while (status == ClipboardTruncate);

    if (status != ClipboardSuccess)
        XBell(XtDisplay(text), 0); /* sƃx炷 */

    /* (20) f[^̎oI */
    XmClipboardEndRetrieve(XtDisplay(text), XtWindow(text));
}
